#!/bin/bash
# Submission script for Blake
#SBATCH --job-name=MC_MG
#SBATCH --time=41:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p blake
#
#SBATCH --comment=test
#SBATCH --output=workspace/MC_MG.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=48
export KMP_PLACE_THREADS=24c,2t
export KMP_AFFINITY=compact

export MKL_NUM_THREADS=${OMP_NUM_THREADS}

function setEnsembleReduction(){
  remove2env INCLUDE "${Trilinos_DIR}/include"
  remove2env LIB "${Trilinos_DIR}/lib"
  remove2env PYTHONPATH "${Trilinos_DIR}/lib/python2.7/site-packages"
  remove2env LD_LIBRARY_PATH "${Trilinos_DIR}/lib/python2.7/site-packages/PyTrilinos"
  remove2env LD_LIBRARY_PATH "${Trilinos_DIR}/lib/python2.7/site-packages"
  remove2env LD_LIBRARY_PATH "${Trilinos_DIR}/lib"
  if [ “$1” == “false” ]; then
    export Trilinos_DIR=$Trilinos_DIR_NO_ER
    export Waves_DIR=$Waves_DIR_NO_ER
    export ensemble_reduction="false"
  else
    export Trilinos_DIR=$Trilinos_DIR_ER
    export Waves_DIR=$Waves_DIR_ER
    export ensemble_reduction="true"
  fi
  add2env INCLUDE "${Trilinos_DIR}/include" end
  add2env LIB "${Trilinos_DIR}/lib" end
  add2env PYTHONPATH "${Trilinos_DIR}/lib/python2.7/site-packages" front
  add2env LD_LIBRARY_PATH "${Trilinos_DIR}/lib/python2.7/site-packages/PyTrilinos" end
  add2env LD_LIBRARY_PATH "${Trilinos_DIR}/lib/python2.7/site-packages" end
  add2env LD_LIBRARY_PATH "${Trilinos_DIR}/lib" end
  cd $Waves_DIR
}

setEnsembleReduction false

python run.py -k ${OMP_NUM_THREADS} katoptron/CMAME/tests/plate_MC_MG_all_cases.py

setEnsembleReduction true

python run.py -k ${OMP_NUM_THREADS} katoptron/CMAME/tests/plate_MC_MG_all_cases.py
