close all
clc
clear all

Afull = load('matrixA.txt');
A = sparse(Afull);

b = load('vector_after_bc.text');

if size(b,2) == 2
    b = b(:,1);
end

solution_1it_ensemble1 = load('multi_frequence_ensemble1_belos_1it_solution.text');
solution_1it_ensemble2 = load('multi_frequence_ensemble2_belos_1it_solution.text');
solution_1it_ensemble3 = load('multi_frequence_ensemble3_belos_1it_solution.text');
solution_1it_ensemble4 = load('multi_frequence_ensemble4_belos_1it_solution.text');

guess_ensemble1 = load('multi_frequence_ensemble1_guess.text');
guess_ensemble2 = load('multi_frequence_ensemble2_guess.text');
guess_ensemble3 = load('multi_frequence_ensemble3_guess.text');
guess_ensemble4 = load('multi_frequence_ensemble4_guess.text');

[it_1e, res_1e] = read_belos('multi_frequence_ensemble1_belos_1it.text');
[it_2e, res_2e] = read_belos('multi_frequence_ensemble2_belos_1it.text');

[it_3e, res_3e] = read_belos('multi_frequence_ensemble3_belos_1it.text');
[it_4e, res_4e] = read_belos('multi_frequence_ensemble4_belos_1it.text');


%%
close all
figure
semilogy(it_1e, res_1e,'o','LineWidth',0.5,...
    'MarkerSize',16,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')
hold on
semilogy(it_2e, res_2e,'o','LineWidth',0.5,...
    'MarkerSize',16,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')
semilogy(it_3e, res_3e,'s','LineWidth',0.5,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')
semilogy(it_4e, res_4e,'s','LineWidth',0.5,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')

grid on
box on
set(gca,'fontsize',18)
xlabel('Iteration')
ylabel('(2-Norm Res Vec) / (2-Norm Prec Res0)')
hold off

%%
format long
solution_1it_ensemble1_1 = solution_1it_ensemble1(:,1);
solution_1it_ensemble1_2 = solution_1it_ensemble1(:,2);

solution_1it_ensemble2_1 = solution_1it_ensemble2(:,1);
solution_1it_ensemble2_2 = solution_1it_ensemble2(:,2);

solution_1it_ensemble3_1 = solution_1it_ensemble3(:,1);
solution_1it_ensemble3_2 = solution_1it_ensemble3(:,2);

solution_1it_ensemble4_1 = solution_1it_ensemble4(:,1);
solution_1it_ensemble4_2 = solution_1it_ensemble4(:,2);

guess_ensemble5 = guess_ensemble2;
solution_1it_ensemble5 = [solution_1it_ensemble1(:,1),solution_1it_ensemble4(:,2)];

norm_r0 = zeros(5,3);

norm_r0(1,1) = norm(b-A*guess_ensemble1(:,1));
norm_r0(1,2) = norm(b-A*guess_ensemble1(:,2));

norm_r0(2,1) = norm(b-A*guess_ensemble2(:,1));
norm_r0(2,2) = norm(b-A*guess_ensemble2(:,2));

norm_r0(3,1) = norm(b-A*guess_ensemble3(:,1));
norm_r0(3,2) = norm(b-A*guess_ensemble3(:,2));

norm_r0(4,1) = norm(b-A*guess_ensemble4(:,1));
norm_r0(4,2) = norm(b-A*guess_ensemble4(:,2));

norm_r0(5,1) = norm(b-A*guess_ensemble5(:,1));
norm_r0(5,2) = norm(b-A*guess_ensemble5(:,2));

for i=1:5
    norm_r0(i,3) = sqrt(norm_r0(i,1)^2+norm_r0(i,2)^2);
end

norm_1it = zeros(5,3);

norm_1it(1,1) = norm(b-A*solution_1it_ensemble1_1);
norm_1it(1,2) = norm(b-A*solution_1it_ensemble1_2);

norm_1it(2,1) = norm(b-A*solution_1it_ensemble2_1);
norm_1it(2,2) = norm(b-A*solution_1it_ensemble2_2);

norm_1it(3,1) = norm(b-A*solution_1it_ensemble3_1);
norm_1it(3,2) = norm(b-A*solution_1it_ensemble3_2);

norm_1it(4,1) = norm(b-A*solution_1it_ensemble4_1);
norm_1it(4,2) = norm(b-A*solution_1it_ensemble4_2);

norm_1it(5,1) = norm(b-A*solution_1it_ensemble5(:,1));
norm_1it(5,2) = norm(b-A*solution_1it_ensemble5(:,2));

for i=1:5
    norm_1it(i,3) = sqrt(norm_1it(i,1)^2+norm_1it(i,2)^2);
end

ratio_1it_r0 = zeros(5,4);
for i=1:5
    ratio_1it_r0(i,1:3) = norm_1it(i,:)./norm_r0(i,:);
end

ratio_1it_r0(1:4,4) = [res_1e(end);res_2e(end);res_3e(end);res_4e(end)];

clc
norm_r0
norm_1it
ratio_1it_r0

c_1 = zeros(5,3);
max_abs_error = zeros(5,3);

for i =1:2
    r0 = b-A*guess_ensemble1(:,i);
    %r0 = r0 /norm(r0);
    c_1(1,i) = r0'*(solution_1it_ensemble1(:,i)-guess_ensemble1(:,i))/norm(r0)^2;
    max_abs_error(1,i) = max(abs(guess_ensemble1(:,i)+c_1(1,i)*r0-solution_1it_ensemble1(:,i)));
end

guess = [guess_ensemble1(:,1);guess_ensemble1(:,2)];
r0 = [b-A*guess_ensemble1(:,1);b-A*guess_ensemble1(:,2)];
sol = [solution_1it_ensemble1(:,1);solution_1it_ensemble1(:,2)];
%r0 = r0 /norm(r0);
c_1(1,3) = r0'*(sol-guess)/norm(r0)^2;
max_abs_error(1,3) = max(abs(guess+c_1(1,3)*r0-sol));

for i =1:2
    r0 = b-A*guess_ensemble2(:,i);
    %r0 = r0 /norm(r0);
    c_1(2,i) = r0'*(solution_1it_ensemble2(:,i)-guess_ensemble2(:,i))/norm(r0)^2;
    max_abs_error(2,i) = max(abs(guess_ensemble2(:,i)+c_1(2,i)*r0-solution_1it_ensemble2(:,i)));
end

guess = [guess_ensemble2(:,1);guess_ensemble2(:,2)];
r0 = [b-A*guess_ensemble2(:,1);b-A*guess_ensemble2(:,2)];
sol = [solution_1it_ensemble2(:,1);solution_1it_ensemble2(:,2)];
%r0 = r0 /norm(r0);
c_1(2,3) = r0'*(sol-guess)/norm(r0)^2;
max_abs_error(2,3) = max(abs(guess+c_1(2,3)*r0-sol));

for i =1:2
    r0 = b-A*guess_ensemble3(:,i);
    %r0 = r0 /norm(r0);
    c_1(3,i) = r0'*(solution_1it_ensemble3(:,i)-guess_ensemble3(:,i))/norm(r0)^2;
    max_abs_error(3,i) = max(abs(guess_ensemble3(:,i)+c_1(3,i)*r0-solution_1it_ensemble3(:,i)));
end

guess = [guess_ensemble3(:,1);guess_ensemble3(:,2)];
r0 = [b-A*guess_ensemble3(:,1);b-A*guess_ensemble3(:,2)];
sol = [solution_1it_ensemble3(:,1);solution_1it_ensemble3(:,2)];
%r0 = r0 /norm(r0);
c_1(3,3) = r0'*(sol-guess)/norm(r0)^2;
max_abs_error(3,3) = max(abs(guess+c_1(3,3)*r0-sol));

for i =1:2
    r0 = b-A*guess_ensemble4(:,i);
    %r0 = r0 /norm(r0);
    c_1(4,i) = r0'*(solution_1it_ensemble4(:,i)-guess_ensemble4(:,i))/norm(r0)^2;
    max_abs_error(4,i) = max(abs(guess_ensemble4(:,i)+c_1(4,i)*r0-solution_1it_ensemble4(:,i)));
end

guess = [guess_ensemble4(:,1);guess_ensemble4(:,2)];
r0 = [b-A*guess_ensemble4(:,1);b-A*guess_ensemble4(:,2)];
sol = [solution_1it_ensemble4(:,1);solution_1it_ensemble4(:,2)];
%r0 = r0 /norm(r0);
c_1(4,3) = r0'*(sol-guess)/norm(r0)^2;
max_abs_error(4,3) = max(abs(guess+c_1(4,3)*r0-sol));

for i =1:2
    r0 = b-A*guess_ensemble5(:,i);
    %r0 = r0 /norm(r0);
    c_1(5,i) = r0'*(solution_1it_ensemble5(:,i)-guess_ensemble5(:,i))/norm(r0)^2;
    max_abs_error(5,i) = max(abs(guess_ensemble5(:,i)+c_1(5,i)*r0-solution_1it_ensemble5(:,i)));
end

guess = [guess_ensemble5(:,1);guess_ensemble5(:,2)];
r0 = [b-A*guess_ensemble5(:,1);b-A*guess_ensemble5(:,2)];
sol = [solution_1it_ensemble5(:,1);solution_1it_ensemble5(:,2)];
%r0 = r0 /norm(r0);
c_1(5,3) = r0'*(sol-guess)/norm(r0)^2;
max_abs_error(5,3) = max(abs(guess+c_1(5,3)*r0-sol));

c_1
max_abs_error