function [Nodes,Elements] = readMshFile(filename)

    fileID = fopen(filename,'r');
    
    tline = fgetl(fileID);
 
    stop = false;
    while 1        
        if strcmp(tline,'$Nodes')
            disp('Start reading nodes');
            while 1
                tline = fgetl(fileID);
                if strcmp(tline,'$EndNodes')
                    break
                end    
                tmp = strread(tline);
                if length(tmp) == 1
                    Nodes = zeros(tmp,3);
                else
                   Nodes(tmp(1),:) = tmp(2:4); 
                end
            end
            disp('Stop reading nodes');
        elseif strcmp(tline,'$Elements')
            disp('Start reading elements');   
            while 1
                tline = fgetl(fileID);
                if strcmp(tline,'$EndElements')
                    stop = true;
                    break
                end  
                tmp = strread(tline);
                if length(tmp) == 1
                    Elements = zeros(tmp,9);
                else
                   Elements(tmp(1),1) = tmp(2);
                   
                   switch Elements(tmp(1),1)
                       case 1
                           %segment
                           Elements(tmp(1),(end-1):end)= tmp((end-1):end);
                       case 2
                           %triangle
                           Elements(tmp(1),(end-2):end)= tmp((end-2):end);
                       case 3
                           %quadrangle
                           Elements(tmp(1),(end-3):end)= tmp((end-3):end);
                       case 4
                           %tetrahedron
                           Elements(tmp(1),(end-3):end)= tmp((end-3):end);
                       case 5
                           %hexahedron
                           Elements(tmp(1),(end-7):end)= tmp((end-7):end);
                   end
                    
                end
            end
            disp('Stop reading elements');                
        end
        if stop
            break
        end
        tline = fgetl(fileID);        
    end
    
    fclose(fileID);

end
