// $Id$
// fichier de donnees gmsh


//L = 50.;
//W = 1.;
//H = 5.;
//d = 1.;

//L = 50.;
//W = 5.;
//H = 5.;
H_rigid = 1.;
//d = 1.;

hW = W/2;
hH = H/2;

//n_L = 60;
//n_hW = 3;
//n_hH = 3;

n_L_rigid = 1;
n_W_rigid = 1;
n_H_rigid = 1;


lc = 1;

delta_H = hH+d;

Point(101) = { 0,  -hW,    d, lc};
Point(102) = { 0,   0,    d, lc};
Point(103) = { 0,   hW,    d, lc};
Point(104) = { L,   hW,    d, lc};
Point(105) = { L,   0,    d, lc};
Point(106) = { L,  -hW,    d, lc};

Point(205) = { 0,   -hW, 0, lc};
Point(206) = { 0,    hW, 0, lc};
Point(207) = { L,    hW, 0, lc};
Point(208) = { L,   -hW, 0, lc};

Line(101) = {101, 102};
Line(102) = {102, 103};
Line(103) = {103, 104};
Line(104) = {104, 105};
Line(105) = {105, 106};
Line(106) = {106, 101};
Line(107) = {105, 102};

Line(205) = {205, 206};
Line(206) = {206, 207};
Line(207) = {207, 208};
Line(208) = {208, 205};

Transfinite Line {101,102,104,105} = n_hW+1 Using Progression 1;
Transfinite Line {103,106,107} = n_L+1 Using Progression 1;

Transfinite Line {205,207} = n_W_rigid+1 Using Progression 1;
Transfinite Line {206,208} = n_L_rigid+1 Using Progression 1;

Line Loop(101) = {101,-107,105,106};
Plane Surface(101) = {101};
Transfinite Surface {101};
Recombine Surface {101};

Line Loop(102) = {102,103,104,107};
Plane Surface(102) = {102};
Transfinite Surface {102};
Recombine Surface {102};

Line Loop(202) = {-208,-207,-206,-205};
Plane Surface(202) = {202};
Transfinite Surface {202};
Recombine Surface {202};

Extrude {0, 0, hH}
{
  Surface{101,102}; Layers{n_hH}; Recombine;
}

Extrude {0, 0, hH}
{
  Surface{230,252}; Layers{n_hH}; Recombine;
}

Extrude {0, 0, -H_rigid}
{
  Surface{202}; Layers{n_H_rigid}; Recombine;
}



Physical Volume("Rigid body") = {5};
Physical Surface("Rigid surface") = {202};
Physical Surface("Rigid clamped surface") = {309};
Physical Line("Rigid surface boundary") = {205, 206, 207, 208};

Physical Volume("Beam") = {1,2,3,4};
Physical Surface("Clamped end") = {217,239,261,283,317};
Physical Surface("Loaded surface") = {274,296};
Physical Surface("Beam contact zone") = {101,102};
Physical Surface("Free end") = {269,247,225,291};
Physical Line("Beam contact boundary") = {104,105,106,101,102,103};
Physical Line("Beam contact Dirichlet") = {101,102};

Physical Line("Center of cross section") = {211};

Physical Line("Center of contact surface") = {107};

Mesh.Partitioner = 2;
Mesh.MetisAlgorithm = 2;
Mesh.MshFilePartitioned = 0;
