#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Copyright 2020 University of Liège
# 
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# 
#     http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.



import numpy as np
import matplotlib.pyplot as plt

def main():
    a = np.random.randn(3,3)
    print(a)
    U, s, V = np.linalg.svd(a, full_matrices=True)
    print(U.shape, V.shape, s.shape)
    S = np.zeros((3,3))
    S[:3,:3] = np.diag(s)
    print(np.allclose(a, np.dot(U, np.dot(S,V))))
    print(a - np.dot(U, np.dot(S,V)))
    print(s)

    plt.plot([1,2,3,4])
    plt.ylabel('some numbers')
    plt.show()
    
if __name__ == "__main__":
    main()
