// 2 materiaux


DefineConstant[ Lx = {  1, Min 5, Max 20, Step 1, Name "Lengths/Lx" }  ];
DefineConstant[ Ly1 = {  1, Min 5, Max 20, Step 1, Name "Lengths/Ly1" }  ];
DefineConstant[ Ly2 = {  1, Min 5, Max 20, Step 1, Name "Lengths/Ly2" }  ];
DefineConstant[ Lz = {  1, Min 1, Max  2, Step 1, Name "Lengths/Lz" }  ];

DefineConstant[ Nx = {   1, Min 1, Max 200, Step 10, Name "Mesh/Nx" }  ];
DefineConstant[ Ny1 = {   1, Min 1, Max 200, Step 10, Name "Mesh/Ny1" }  ];
DefineConstant[ Ny2 = {   1, Min 1, Max 200, Step 10, Name "Mesh/Ny2" }  ];
DefineConstant[ Nz = {   1, Min 1, Max 200, Step 10, Name "Mesh/Nz" }  ];

lc = Lx/Nx; // useless

Point(1) = { 0,   0, 0, lc};
Point(2) = { Lx,  0, 0, lc};
Point(3) = { Lx, Ly1+Ly2, 0, lc};
Point(4) = { 0,  Ly1+Ly2, 0, lc};

Point(5) = { 0,  Ly1, 0, lc};
Point(6) = { Lx, Ly2, 0, lc};

Line(1) = {1, 2};
Line(2) = {2, 6};
Line(3) = {6, 5};
Line(4) = {5, 1};
Line(5) = {5, 4};
Line(6) = {4, 3};
Line(7) = {3, 6};



Line Loop(8) = {6, 7, 3, 5};
Plane Surface(9) = {8};
Line Loop(10) = {1, 2, 3, 4};
Plane Surface(11) = {10};

// ---
Transfinite Line {1, 3, 6} = Nx-1 Using Progression 1;
Transfinite Line {2, 4} = Ny1-1 Using Progression 1;
Transfinite Line {7, 5} = Ny2-1 Using Progression 1;
Transfinite Surface {9};
Transfinite Surface {11};
// ---

Recombine Surface {9};
Recombine Surface {11};

Extrude {0, 0, Lz} {
  Surface{9}; Layers{Nz}; Recombine;
}
Extrude {0, 0, Lz} {
  Surface{11}; Layers{Nz}; Recombine;
}


Physical Volume("Volume1") = {2};
Physical Volume("Volume2") = {1};


Physical Surface("FaceY0") = {42};
Physical Surface("FaceX1_1") = {46};
Physical Surface("FaceX1_2") = {24};
Physical Surface("FaceY1") = {20};
Physical Surface("FaceX0_1") = {54};
Physical Surface("FaceX0_2") = {32};



Physical Line("Line1") = {40};


