/*
 * Copyright 2020 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WWAVETERM_H
#define WWAVETERM_H

#include "waves.h"

#include <vector>
#include <Eigen/Dense>

namespace waves
{

/**
 * @brief Formulation of wave terms
 */
class WAVES_API WaveTerm
{
public:
    // Stiffness matrix
    static Eigen::MatrixXd buildK(tbox::Element const &e, std::vector<double> const &u);
    // Mass matrix
    static Eigen::MatrixXd buildM(tbox::Element const &e);
};

} // namespace waves
#endif //WWAVETERM_H
